// rocknroll.js    

var mem = [];
var prev_mem = [];
var count = 0;

var h_margin = 300;
var v_margin = 12;
var v_offset = 2;

var dragging = 0;
var sel = -1;

function bang() {
    for (i=0; i<mem.length; i++) {
        this.patcher.remove(mem[i]);
    }
    count = 0;
    mem = [];
    post("mem",mem.length,"\n");
}

function create(name) {
    var obj = this.patcher.newdefault(0, 0, "bpatcher", 
        "@varname", 
        "obj["+count+"]", 
        "@name", name, 
        "@patching_rect", h_margin, v_margin+count*90, 100, 78);
    mem.push(obj);
    this.patcher.connect(mem[count-1],0,mem[count],0);
    count++;
    post("mem",mem.length,"\n");
}

function list(x,y) {
    if (dragging && this.patcher.locked) {
        if (sel == -1) {
            for (i=mem.length-1; i>=0; i--) {
                if (x>mem[i].rect[0] && x<=mem[i].rect[0]+27 && y>mem[i].rect[1] && y<=mem[i].rect[1]+27) {
                    sel = i;
                    dx = x-mem[i].rect[0];
                    dy = y-mem[i].rect[1];
                }
            }
            if (sel == -1) {
                dragging = 0;
            }
        } else {
            width = mem[sel].rect[2]-mem[sel].rect[0];
            height = mem[sel].rect[3]-mem[sel].rect[1];
            mem[sel].rect = [x-dx,y-dy,x-dx+width,y-dy+height];
        }
    }
}

function msg_int(x) {
    dragging = x;
    if (!dragging && sel != -1) {
        sel = -1;
        repatch();
    }
}

function repatch() {
//    post(compare(prev_mem,mem),"\n");
//    if (!compare(prev_mem,mem)) {
        post("repatching\n");
        for (i=0; i<mem.length-1; i++) {
            this.patcher.disconnect(mem[i],0,mem[i+1],0);
        }
//        prev_mem = mem.slice();
        mem.sort(order);
        for (i=0; i<mem.length-1; i++) {
            this.patcher.connect(mem[i],0,mem[i+1],0);
        }
//    }
}

function compare(a,b) {
    for (i=0; i<a.length; i++) {
        if (a[i] != b[i]) {
            return false;
        }
    }
    return true;
}

function order(a,b) {
    return a.rect[1]-b.rect[1];
}

autowatch = 1;

// EOF